<?
/**
 ============================================================================
 @desc as_maillib.php - PHP wrapper class for easy preparing & sending emails
 multiple file attach support (mime auto-encoded),
 qp_encoding function stolen from open sources.
 @author Alexander Selifonov, http://as-works.narod.ru
 @copyright Alexander Selifonov
 @version 1.0.003
 @modified 12.11.2007 (dd.mm.yyyy)
 ============================================================================
**/
if(!defined('BASE_CHARSET'))
  define('BASE_CHARSET','Windows-1251'); // Your charset here, like "iso-8859-1"

class CSmtpSender { // Sending SMTP message wrapper class
  var $body = '';
  var $subject = '';
  var $files = array(); // attached files
  var $charset = BASE_CHARSET;
  var $fromaddr = '';
  var $headers = '';
  var $txtbody = '';
  var $To = '';
  var $msg_prepared = false;
  var $txtBodyType = 'text/plain';
  var $debug = 0;
  function GetMimeType($filename) {
    $splt = explode('.',$filename);
    $fext = count($splt)>1 ? strtolower($splt[count($splt)-1]) : '';
    unset($splt);
    switch($fext) {
    case 'jpg': case 'jpeg': case 'jpe': return 'image/jpeg';
    case 'bmp': case 'png': case 'gif': return "image/$fext";
    case 'tif': case 'tiff': return 'image/tiff';
    case 'swf': return 'application/x-shockwave-flash';
    case 'wav': case 'mp3': return "audio/$fext";
    case 'rtf': return 'application/rtf';
    case 'xls': return 'application/vnd.ms-excel';
    case 'pps': case 'ppt': case 'ppz': return 'application/vnd.ms-powerpoint';
    case 'doc': case 'dot': case 'wrd': return 'application/vnd.ms-word';
    case 'tgz': case 'gtar': return 'application/x-gtar';
    case 'gz': return 'application/x-gzip';
    case 'zip': return 'application/zip';
    case 'rar': return 'application/rar';
    case 'ico': return 'image/x-icon';
    case 'txt': return 'text/plain';
    case 'htm': return 'text/html';
    case 'html': return 'text/html';
    case 'xml': case 'xsl': return 'text/xml';
    case 'mpg': case 'mpe': case 'mpeg': return 'video/mpeg';
    case 'qt': case 'mov': return 'video/quicktime';
    case 'avi': return 'video/x-ms-video';
    case 'wm': case 'wmv': case 'wmx': return "video/x-ms-$fext";
    }
    return 'octet-stream';
  }
  function AddFile($fullpath, $filename='') {
     if(!is_readable($fullpath)) return false;
     if($filename ==='') {
         $splt = split('[/\]', $fullpath);
         $filename = $splt[count($splt)-1];
     }
     $this->files[] = array($fullpath, $filename);
     return true;
  }

  function SetSubject($subj) {
    $this->subject = $subj;
  }
  function SetTo($strg) {
    $this->To = $strg;
  }
  function AddBody($body, $bodyType='') {
    $this->txtbody .= $body;
    if($bodyType !='') {
      $this->txtBodyType = $bodyType;
      if(strpos($this->txtBodyType,'/')===false) $this->txtBodyType = "text/$bodyType";
    }
  }
  function AddHeader($hdname, $hdcontents) {
    $this->headers .= "$hdname: $hdcontents\r\n";
  }
  function Init() {
     $this->txtbody = '';
     $this->To = '';
     $this->headers = '';
     $this->subject = '';
     $this->charset = BASE_CHARSET;
     $this->files = array();
  }
  function Send($toAddress='',$subj='',$body='') {
    $retcode = 0;
    $b_emulatesend =file_exists('_as_maillib_emulate.$$$');
    $file_forward = '_as_maillib.fwd';
    if(file_exists($file_forward)) {
      $fwd = @file($file_forward);
      $fwdaddress = trim($fwd[0]);
      if(strpos($fwdaddress,'@')===false) $fwdaddress = '';
    }
    if($toAddress!='') $this->To = $toAddress;
    if($subj!=='') $this->subject = $subj;
    if($body!=='') $this->txtbody = $body;
    if(!empty($fwdaddress)) {
      $this->txtbody = "[!]as_maillib:Debug forwarded from address {$this->To}.\r\n".$this->txtbody;
      $this->To = $fwdaddress;
    }
    if($this->txtBodyType=='text/html')
       $this->txtbody = nl2br($this->txtbody);
    if(strpos($this->To,'@')===false) {  return 0; }

    $mime_boundary = '==Boundary_'.md5(time());

    $rawbody = '';
    $headers = $this->headers;
    $headers .= "MIME-Version: 1.0\r\nContent-Type: multipart/mixed; boundary=\"{$mime_boundary}\"";
    $rawbody = '';
    if($this->txtbody !='') {
       $rawbody = "This is a multi-part message in MIME format.\r\n\r\n" .
         "--{$mime_boundary}\r\n" .
         "Content-Type:{$this->txtBodyType}; charset=\"{$this->charset}\"\r\n" .
         "Content-Transfer-Encoding: quoted-printable\n\n" .
         qp_encoding($this->txtbody)."\r\n\r\n";
    }
    if(!($b_emulatesend) && count($this->files)>0) { #<3>
      for($kk=0; $kk<count($this->files); $kk++) { #<4> - encode attached file...
         $file = (is_file($this->files[$kk][0]))? fopen($this->files[$kk][0],'rb') : 0;
         if(empty($file)) { continue; }
         $fileatt_type = $this->GetMimeType($this->files[$kk][0]);
         $data = fread($file,filesize($this->files[$kk][0]));
         fclose($file);
         $end = ($kk<count($this->files)-1)? '':'--';
         $data = chunk_split(base64_encode($data));

         $rawbody .= "--{$mime_boundary}\n" .
           "Content-Type: {$fileatt_type};\n name=\"{$this->files[$kk][1]}\"\r\n" .
           "Content-Transfer-Encoding: base64\r\n" .
           "Content-Disposition: attachment;\n filename=\"{$this->files[$kk][1]}\"\r\n\r\n" .
           $data . "\n\n--{$mime_boundary}{$end}\r\n";
         unset($data);
         unset($file);
         unset($fileatt_type);
      } #<4>
    } #<3>
    if($b_emulatesend) {
      $retcode = 1;
      $fout = @fopen('./_as_maillib_emulate.log','a');
      if($fout) {
        @fwrite($fout,"\n<=== ".date('Y-m-d H:i:s')." === email send emulated ==============================================\n");
        @fwrite($fout,"<=== To: {$this->To}\n");
        @fwrite($fout,"subject: {$this->subject}\n");
        for($kk=0; $kk<count($this->files); $kk++) { #<4> - encode attached file...
           @fwrite($fout,"<=== attach: {$this->files[$kk][0]}\n");
        }
        @fwrite($fout,"{$this->txtbody}\n");
        @fclose($fout);
      }
    }
    else {
      $retcode = @mail($this->To,$this->subject,$rawbody,$headers);
    }
    if($this->debug) {
        $dout = @fopen('as_mail-debug.log','a');
        if($dout) {
            fwrite($dout,date('d.m.Y H:i')." mail to:'{$this->To}', subj='{$this->subject}' result=$retcode\n");
            fclose($dout);
        }
    }
    unset($rawbody);
    return $retcode;
  } // SendMessage() end
} // CSmtpSender definition end

function qp_encoding($Message)
{ // encode text as quoted_printable (for transfer in 7-bit form mail message)

   /* Build (most polpular) Extended ASCII Char/Hex MAP (characters >127 & <255) */
   for ($i=0; $i<127; $i++) {
       $CharList[$i] = "/".chr($i+128)."/";
       $HexList[$i] = "=".strtoupper(bin2hex(chr($i+128)));
   }

   /* Encode equal sign & 8-bit characters as equal signs followed by their hexadecimal values */
   $Message = str_replace("=", "=3D", $Message);
   $Message = preg_replace($CharList, $HexList, $Message);

   /* Lines longer than 76 characters (size limit for quoted-printable Content-Transfer-Encoding)
       will be cut after character 75 and an equals sign is appended to these lines. */
   $MessageLines = split("\n", $Message);
   $Message_qp = "";
   while(list(, $Line) = each($MessageLines)) {
       if (strlen($Line) > 75) {
           $Pointer = 0;
           while ($Pointer <= strlen($Line)) {
               $Offset = 0;
               if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+73), 3))) $Offset=-2;
               if (preg_match("/^=(3D|([8-9A-F]{1}[0-9A-F]{1}))$/", substr($Line, ($Pointer+74), 3))) $Offset=-1;
               $Message_qp.= substr($Line, $Pointer, (75+$Offset))."=\r\n";
               if ((strlen($Line) - ($Pointer+75)) <= 75) {
                   $Message_qp.= substr($Line, ($Pointer+75+$Offset))."\r\n";
                   break 1;
               }
               $Pointer+= 75+$Offset;
           }
       } else {
           $Message_qp.= $Line."\r\n";
       }
   }
   return $Message_qp;
}

?>